Mobile Bundles
==============

This is the standard way of allowing users to access the content they have purchased from iOS/Android
devices.


New-style Downloads
-------------------

From a User's Items or from a User's Borrowed Items, a link will be included with the download location for that
User.

.. code-block:: http

    HTTP/1.1 200 OK
    Content-Type: application/json

    {
        "id": 745823,
        "title": "Into to Algebra",
        "details": {
            "href": "https://api.apps-foundry.com/items/9998",
            "title": "Detil Item"
        },
        "owner": {
            "href": "https://api.apps-foundry.com/organizations/1",
            "rel": "organization",
            "title": "Apps-Foundry Shared Library"
        },
        "catalog": {
            "href": "https://api.apps-foundry.com/organizations/1/shared-catalogs/1",
            "rel": "catalog",
            "title": "Math Books"
        },
        "cover_image": {
            "href": "https://images.getscoop.com/items/cover-images/9998.jpg",
            "title": "Gambar Sampul"
        },
        "download": {
            "href": "https://api.apps-foundry.com/items/9998/download",
            "title": "Download buat Baca Offline"
        },
        "streaming": {
            "href": "https://api.apps-foundry.com/items/9998/web-reader",
            "title": "Baca Sekarang"
        },
        "expires": "2016-10-10T01:23:45Z",
        "last_read_time": "2016-10-10T01:23:45Z",
        "last_read_page": 12
    }


The download URL will be denoted by the ``download`` object.

This version of the downloader supports a wide range of HTTP request headers to allow you to access the download
however best suites your device.

.. note::

    This example is for a partial download, that will only download the first 10 (Si) kB of the file.
    To directly download the file in one shot, do not include the Range parameter.

.. code-block:: http

    GET /items/9998/download HTTP/1.1
    Accept: application/zip
    Accept-Language: id-ID
    Authorization: Bearer MTIzNDp3ZTRzY29vcA==
    Range: bytes=0-9999
    User-Agent: PerPusNas IOS/1.0.0 (iOS 3.2.1; iPhone 6s)

.. code-block:: http

    HTTP/1.1 200 OK
    Connection: keep-alive
    Content-Length: 10000
    Content-Range: bytes 0-9999/23620240
    Content-Type: application/zip
    Date: Fri, 13 May 2016 04:51:29 GMT
    ETag: "54ed3eac-1686a90"
    Last-Modified: Wed, 25 Feb 2015 03:17:00 GMT

    << some binary content as the response body >>


Old-style Downloads
-------------------

.. deprecated:: May 12, 2016.

    Because of security and performance updates on backend, this is no longer required.
    This feature will be removed from the API on May 12, 2017.


Download resource, used to authorize and create the download for client side. The returned download's URL(s) only
active for a very short period and must be used to connect to the downloads immediately.

This resource will only returns success response if the requested user_id and item_id is matched on user's owned
items resource.


Generate Signature
^^^^^^^^^^^^^^^^^^

Client needs to send **signature** parameter on request to download resource. To obtain the signature, some keys are
created by looping the hash function within some data. The number of key is determined based on the last two digits of
timestamp_unix + 1. The signature is taken from the latest key, which is generated by crypting DOWNLOAD_SALT and the
predecessor key with SHA-256 hash function. The first key is generated by crypting DOWNLOAD_SALT and Format_data
with SHA-256 hash function.


.. code-block:: python

    timestamp_unix = 192461648711

    Keys = 11 + 1 = 12

    DOWNLOAD_SALT  = "36yjfhjgy86o75i6urkyfhjgvbcftdfgnbccnhu756yjthmfgjgk876uky76iyjtd"

    FORM1 = Integer(<item_id> x 2)

    FORM2 = Integer(<user_id> + <timestamp_unix>)

    Format_data = String(<timestamp_unix> + FORM1 + FORM2 + <DOWNLOAD_SALT>)

    Key1 = sha256(<DOWNLOAD_SALT> + Format_data)

    Key2 = sha256(<DOWNLOAD_SALT> + Key1)

    Key3 = sha256(<DOWNLOAD_SALT> + Key2)

    ...

    Key12 = sha256(<DOWNLOAD_SALT> + Key11)

    SIGNATURE = key12


Key Encryption
^^^^^^^^^^^^^^

AES Mode = CBC

SHARED KEY = "tuyjsue93iruydgkui7u6ryejtdghfjg"

**Key Encription:**
```
ENCODE_KEY = BASE64.ENCODE(<AES_KEY>)

KEY = <IV>+ENCODE_KEY
```

Download Properties
^^^^^^^^^^^^^^^^^^^

url
    String; Encrypted location that refers to the item
is_active
    Boolean; Download status
md5_checksum
    String; The hash encryption key used within the download
file_type
    Number; The type of the file that will be downloaded
file_status
    Number; The status of the file that will be downloaded
file_order
    Number; The number of file order
key
    String; Combination of IV 16 digits and AES key
item_id
    Number; Item identifier


Authorize and Create Download
^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

Authorize and create download. The use case for this end-point call is to check if the user eligible to download
specific item files. If eligible, the detail of eligible files will be returned; otherwise,
"403 Forbidden" will be returned.

Created download instance will only active for 15 minutes.

**URL:** /downloads

**Method:** POST

**Request Data Params:**

Required: `user_id`, `item_id`, `timestamp_unix`, `signature`

Optional: `country_code`, `ip_address`, `file_orders` - can be filtered with operator `__in`, `__lte`, or `__gte` to get specified files

albeit `country_code` and `ip_address` are optional, one of them must be filled otherwise the request will be rejected.

**Response HTTP Code:**

* `201` - Download created and returned in body content

**Response Params:** See [Downloads Properties](#downloads-properties)

**Examples:**

Request with file orders specified in each:

.. code-block:: http

    POST /downloads HTTP/1.1
    Content-Type: application/json
    Authorization: Bearer ajksfhiau12371894^&*@&^$%

    {
        "user_id": 307019,
        "item_id": 50377,
        "timestamp_unix": 192461648711,
        "signature": "e30838dc8400660940d2418e3c1abf55ec97876e69e9d9f73bdd0974dccdc2f6",
        "file_order__in": [1, 2, 3, 4, 5],
        "file_order__gte": 1,
        "file_order__lte": 20,
        "country_code": "ID",
        "ip_address": "139.0.18.154"
    }


Success response:

.. code-block::

    HTTP/1.1 200 OK
    Content-Type: application/json; charset=utf-8

    {
        "downloads": [
            {
                "url": "http://182.253.226.134/Xkr6jVqvsydbhV2E8uuGpI1H1eVi1ubDo4xUTkD2T34FMI66tBATVfmMhfVP",
                "file_version": "1",
                "is_active": true,
                "md5_checksum": null,
                "file_type": 1,
                "file_status": 1,
                "file_order": 1,
                "key": "gAwkLuU4x5R6lcFEmT2EP6ynfDvLewCScaDlVxgvG6Q9KvtUmRxiZ3nsx4mu6eZOsW7SA038ZrFtDLTdIhHkIXfQArOuEbcVJ8VaNw==",
                "item_id": 27335
            }
        ],
        "metadata": {
            "resultset": {
                "count": 1,
                "offset": 0,
                "limit": 0
            }
        }
    }


Fail response:

.. code-block:: http

    HTTP/1.1 403 Forbidden
    Content-Type: application/json; charset=utf-8

    {
        "status": 403,
        "error_code": 403102,
        "developer_message": "Forbidden. Access denied"
        "user_message": "Access denied"
    }
